#include <iostream>
#include <vector>
#include <cmath>
#include <cassert>
using namespace std;

const char iname[] = "afaceri.in";
const char oname[] = "afaceri.out";

const int MAX_N = 805;

#define FOR(i, a, b)  for (int i = (a); i <= (b); ++ i)

vector < pair <int, int> > airports[MAX_N];
int n;  double dp[MAX_N][MAX_N][4][4];


double edist(pair <int, int>& a, pair <int, int>& b) {
    return sqrt((a.first - b.first) * (a.first - b.first) +
                (a.second - b.second) * (a.second - b.second));
}

int main(void) {
    FILE *fi = fopen(iname, "r");
    fscanf(fi, "%d", &n);
    FOR (i, 1, n) FOR (j, 1, 4) {
        int x, y;
        fscanf(fi, "%d %d", &x, &y);
        airports[i].push_back(make_pair(x, y));
    }
    fclose(fi);

    FOR (i, 1, n) FOR (j, 1, n) FOR (a, 0, 3) FOR (b, 0, 3)
        dp[i][j][a][b] = 1e9;
    FOR (a, 0, 3) FOR (b, 0, 3)
        dp[1][2][a][b] = edist(airports[1][a], airports[2][b]);
    FOR (i, 1, n) FOR (j, i + 1, n) FOR (a, 0, 3) FOR (b, 0, 3) {
        if (j >= i + 2) {
            FOR (c, 0, 3) {
                dp[i][j][a][b] = min(dp[i][j][a][b], dp[i][j - 1][a][c] +
                    edist(airports[j - 1][c], airports[j][b]));
            }
        } else if (j == i + 1) {
            FOR (k, 1, i - 1) FOR (c, 0, 3) {
                dp[i][j][a][b] = min(dp[i][j][a][b], dp[k][i][c][a] +
                    edist(airports[k][c], airports[j][b]));
            }
        }
    }

    double min_ed = 1e9;
    FOR (i, 1, n - 1) FOR (a, 0, 3) FOR (b, 0, 3)
        min_ed = min(min_ed, dp[i][n][a][b] + edist(airports[i][a], airports[n][b]));

    fprintf(fopen(oname, "w"), "%lf\n", min_ed);

    return 0;
}
